{{
'-------------------------------------------------------------------------------
'                         !!! IMPORTANT NOTE !!!
'                         ======================
'    If the name of this file does not end in "_Input.spin", then this
'    is not the original file - it is a processed version that will get 
'    overwritten by the next compile. Do not change this file - instead, 
'    locate the original version (normally in the 'input' subdirectory of 
'    the Catalina target directory) and modify that version of this file.
'-------------------------------------------------------------------------------
'
' LMM_default - an LMM target for Catalina LMM Programs. 
'
' The following symbols affect the kernel and plugins:
'
'   PLUGIN - load and start the Generic Plugin
'                 
' Version 2.8 - initial version
'                 
'-------------------------------------------------------------------------------
}}
CON
'
' Set these to suit the platform by modifying "Catalina_Common"
' That is where the PIN definitions for all platforms are defined.
'
_clkmode  = Common#CLOCKMODE
_xinfreq  = Common#XTALFREQ
_stack    = Common#STACKSIZE
'
OBJ
'
' The following object MUST be loaded ...
'
  Catalina : "Catalina"                                 ' The program to run
'
' If you have additional objects that must be available at run-time, put them
' here (i.e. between Catalina and Catalina_Common) ...
'         
'
' The following object MUST be loaded ...
'
  Common   : "Catalina_Common"                          ' Common Definitions
'
' The following object MUST be loaded ...
'
  Kernel   : "Catalina_LMM"                             ' The Catalina Kernel
'
' The following objects are optional:
'
#ifdef PLUGIN
  PLUGIN   : "Catalina_Plugin"                          ' Generic Plugin
#endif
'
'
' Start - This is the main initialization routine - it 
' initializes all plugins and then start the Kernel.
'
PUB Start : ok | cog, ALLOC, PLUGIN_BLOCK

  ' Set up the Registry
  Common.InitializeRegistry

  ' Point to just below the Registry area - we allocate any
  ' dedicated data blocks downwards from here in Hub RAM
  ALLOC := Common#REQUESTS

  ok := TRUE

#ifdef PLUGIN

  if ok

    ' allocate a data block for our PLUGIN
    PLUGIN_BLOCK := ALLOC - PLUGIN#BLOCK_SIZE
    ALLOC := PLUGIN_BLOCK

    ' start the Plugin - in this cae, the parameter we pass is 
    ' the address of an approporiately sized block of Hub RAM,
    ' allocated specifically for this Plugin to use - this is
    ' plugin-dependent, and is intended only as an example.
    ok := Plugin.Start(Common#REGISTRY, ALLOC)

#endif

  if ok

    ' Plugins now loaded- start the LMM by giving it the address
    ' of the top of RAM (to use as the initial SP) and also the base 
    ' address of the Catalina program to execute. The address of the
    ' initial SP is just below any Hub RAM we allocated to our plugins.
    Kernel.Run (Common#REGISTRY, Common#REQUESTS, Catalina.Base, ALLOC)

  else

    ' what?
  
{{

+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
}}  
